﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

namespace Wczytanie_pliku_DLL_albo_EXE
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            textBox1.Text = Application.ExecutablePath; //zm: JM
        }

        private void LoadFileButton_Click(object sender, EventArgs e)
        {
            //string path = "F:\\Studia\\ROK_II\\MojaBiblioteka.dll";
            string path = textBox1.Text;

            if (!File.Exists(path)) MessageBox.Show("Wskazany plik nie istnieje", Text, MessageBoxButtons.OK, MessageBoxIcon.Warning); //zm: JM

            Assembly myDll = null;

            try
            {
                myDll = Assembly.LoadFrom(path);
            }
            catch (IOException fileNotFoundException)
            {
                return;
            }

            myTreeView.Nodes.Clear();
            
            TreeNode leafs = null;
            int ClassIndex = 0;
            const int MethodIndex = 0, FieldIndex = 1, PropertyIndex = 2;

            foreach(Type t in myDll.GetTypes().Where(x => x.IsClass))
            {
                if (leafs == null || leafs.Text != t.Namespace)
                {
                    if (leafs != null)
                        myTreeView.Nodes.Add(leafs);

                    ClassIndex = 0;
                    leafs = new TreeNode(t.Namespace);
                }

                leafs.Nodes.Add(t.Name);
                leafs.Nodes[ClassIndex].Nodes.Add("Class Methods");
                leafs.Nodes[ClassIndex].Nodes.Add("Class Fields");
                leafs.Nodes[ClassIndex].Nodes.Add("Class Properties");

                MethodInfo[] methods = t.GetMethods();
                foreach (MethodInfo m in methods)
                {
                    leafs.Nodes[ClassIndex].Nodes[MethodIndex].Nodes.Add(m.Name);
                }

                FieldInfo[] fields = t.GetFields();
                foreach (FieldInfo f in fields)
                {
                    leafs.Nodes[ClassIndex].Nodes[FieldIndex].Nodes.Add(f.Name);
                }

                PropertyInfo[] properties = t.GetProperties();
                foreach (PropertyInfo p in properties)
                {
                    leafs.Nodes[ClassIndex].Nodes[PropertyIndex].Nodes.Add(p.Name);
                }

                ClassIndex++;
            }

            myTreeView.Nodes.Add(leafs);
        }
    }
}
